
#include "h.h"
#include "hw.h"
#include "par.h"
#include "ui.h"
#include "proceso.h"

#pragma udata u2
u16  wClave;     // clave secreta

#pragma code general
#include "parametr.h"

//carga datos desde ROM/EEPROM
//respeta variables marcadas con NVRAM, poner bit para permitir reinicializar
void PARReset(void)
{
u16 n,f;
//?lo siguiente podria ser una union
u8  *u;
u16 *w;
s16 *s;
u32 *q;
u32 l;
for(n=0;n!=MAXPAR;n++)
    {
    q=(void*)(par[n].pVar);
    if(q==0)continue;
    u=(u8*)(q);
    w=(u16*)(q);
    s=(s16*)(q);
    f=par[n].flags;
    l=par[n].lTip;
    if(bEEPROM)
        {
        if(f&NVRAM)  //las variables que residen en ram no se inicializan
            continue; 
        if(f&E2P)    //recupera valor desde eeprom
            {
		    u16 a;
		    a=n<<2;
			       l= EEPROMRead(a+3);
		    l<<=8; l+=EEPROMRead(a+2);
		    l<<=8; l+=EEPROMRead(a+1);
		    l<<=8; l+=EEPROMRead(a);
            }
        }
    if(!bEEPROM&&(f&E2P))
        {
        //guarda valor en la eeprom
		u16 a;
		u32 d;
		a=n<<2;
		d=l;   EEPROMWrite(a  ,(u8)d);  //LSB
		d>>=8; EEPROMWrite(a+1,(u8)d);
		d>>=8; EEPROMWrite(a+2,(u8)d);
		d>>=8; EEPROMWrite(a+3,(u8)d);  //MSB
        }
    if(f&U8 )(*u)=(u8 )(l); else
	if(f&U32)(*q)=(u32)(l); else
	if(f&S16)(*s)=(s16)(l); else
	if(f&U16)(*w)=(u16)(l);
	}
if(!bEEPROM)
    {
	EEPROMWrite(0,0xAA);
    }
}

//verifica coherencia datos
void PARLoop(void)
{

}

