
//Mi sueo es el de Picasso:
//Tener mucho dinero para vivir tranquilo como los pobres
//Fernando Savater. (1947) Filsofo espaol.

/*
20070116 control min,max durante edicion parametro
*/


/*
MANEJO CORRECTO PUNTEROS A VARIABLES
int x;
float r;
void *p = &x;    // p points to x
int main (void) {
   *(int *) p = 2;
   p = &r;  // p points to r
   *(float *)p = 1.1;
}
*/

#include "h.h"
#include "hw.h"
#include "par.h"

//#ifndef PIC18
#define UP    'x'
#define DOWN  'c'
#define ESC   'z'
#define OK    'v'
#define END   'e'
//#endif
/*
#ifdef PIC18
#define ESC   0x80
#define UP    0x40
#define DOWN  0x20
#define OK    0x10
#define END   0xff
#endif
*/

#define REFRESHTIME 1
#define BLINK 1

void incrementaaux(void);
void decrementaaux(void);
void GenLin(u16);
void view(u16);
void edit(void);
void edit_ok(void);

extern ENROM struct _tpar par[MAXPAR];

#pragma udata u1
//private
u16  blink;      //parpadeo del cursor > en modo edicion
char s[TAMH];
u16  pan[TAMV];  //nodo a visualizar en cada linea
u32  tempsui;    //instante en el que refrescar la pantalla
u8   cupan,      //cursor en pantalla
	 cupanv,     //cursor parametro visualizado
	 cupar,      //parametro que esta siendo editado
	 eui;        //modo: 0 arranque, parametro 0x00 , submenu 0x80  o edicion 0x40
s32  lauxe,      //valor que esta siendo editado
	 lauxv;      //valor que esta siendo visualizado
u8   uIdioma;    // 0esp 1ing 2fra

#pragma code general

//////////////////////////////////////////////////////////////////////////
//
// funciones consulta arbol
//
u16 primero(u16 nodo)
{
u16 n,padre;
for(n=0;n!=MAXPAR;n++)if(par[n].nodo==nodo)break;
if(n==MAXPAR)return 0;
padre=par[n].padre;
for(n=0;n!=MAXPAR;n++)if(par[n].padre==padre)break;
if(n==MAXPAR)return 0;
return par[n].nodo;
}

u16 ultimo(u16 nodo)
{
u16 n,padre;
for(n=0;n!=MAXPAR;n++)if(par[n].nodo==nodo)break;
if(n==MAXPAR)return 0;
padre=par[n].padre;
//ojo comparacion n del for
for(n=MAXPAR-1;n;n--)if(par[n].padre==padre)return par[n].nodo;
return 0;
}

u16 anterior(u16 nodo)
{
u16 n,padre;
for(n=0;n!=MAXPAR;n++)if(par[n].nodo==nodo)break;
if(n==MAXPAR)return 0;
padre=par[n].padre;
//ojo comparacion for, si nodo=0 ?falla?
n--;
for(;n;n--)if(par[n].padre==padre)return par[n].nodo;;
return 0;
}

u16 siguiente(u16 nodo)
{
u16 n,padre;
if(nodo==0)return 0; // optimiza
for(n=0;n!=MAXPAR;n++)if(par[n].nodo==nodo)break;
if(n==MAXPAR)return 0;
padre=par[n].padre;
n++;
for(;n!=MAXPAR;n++)if(par[n].padre==padre)break;
if(n==MAXPAR)return 0;
return par[n].nodo;
}

u16 padre(u16 nodo)
{
u16 n,padre;
for(n=0;n!=MAXPAR;n++)if(par[n].nodo==nodo)return(par[n].padre);
return 0;
}

u16 hijo(u16 nodo)
{
u16 n;
for(n=0;n!=MAXPAR;n++)
  if(par[n].padre==nodo)
	{
	//nodoi=n;
	//nodo=par[n].nodo;
	return par[n].nodo;
	}
return 0;
}
//////////////////////////////////////////////////////////////////////////

//optimizar
void strncpy2(char *d,ENROM char *s,u16 n)
{
u16 i;
for(i=0;i!=n;i++)
	{
	if(*s==0)return;
	*d=*s;
	s++;
	d++;
	}
}


void strlcpy(char *d,ENROM char *s,u16 n)
{
for(;n;n--)
	{
	if(*s==' ')return;
	*d=*s;
	s--;
	d--;
	}
}


void VerS32(char *s,s32 n)
{
bit sig;
u8  r;
s32 q;
if(n<0)
	{
	sig=1;
	n=-n;
	}
else sig=0;
do
	{
	q=n/10;
	r=n%10;
	n=q;
	*s='0'+r;
	s--;
	}
while(n>0);
if(sig){*s='-';s--;}
*s=' ';
}
//////////////////////////////////////////////////////////////////////////



void scrolldown(void)
{
u16 n;
if(pan[1]!=primero(pan[1]))
  for(n=1;n!=TAMV;n++)pan[n]=anterior(pan[n]);
}

void scrollup(void)
{
u16 n;
if(pan[TAMV-1]!=ultimo(pan[TAMV-1]))
  for(n=1;n!=TAMV;n++)
		pan[n]=siguiente(pan[n]);
}

void cursorup(void)
{
if(cupan!=1)cupan--;
else scrolldown();
}

void cursordown(void)
{
if(cupan<TAMV-1 && pan[cupan+1])cupan++;
else scrollup();
}

void menuok(void)
{
u16 n,nodo;
nodo=pan[cupan];
//printf("\n\n menuok, estoy en pan[%d]=%d\n",cupan,nodo);
pan[0]=nodo;
pan[1]=hijo(nodo);
//printf("hijo %d\n",pan[1]);
for(n=2;n!=TAMV;n++) { pan[n]=siguiente(pan[n-1]); /*printf("siguiente %d\n",pan[n]);*/ }
cupan=1; //selecciono la primera opcion...
}

void incrementaaux(void)
{
long min,max;
min=par[cupar].lMin;
max=par[cupar].lMax;
if(lauxe<=min)lauxe=min;
if(lauxe>=max)lauxe=max;
else lauxe++;
}

void decrementaaux(void)
{
long min,max;
min=par[cupar].lMin;
max=par[cupar].lMax;
if(lauxe>=max)lauxe=max;
if(lauxe<=min)lauxe=min;
else lauxe--;
}

void menuesc(void)
{
u16 nodo;
nodo=pan[cupan];
//printf("\n\n\n\n\n estoy en pan[%d]=%d\n",cupan,nodo);
nodo=padre(nodo);
if(nodo!=1)nodo=padre(nodo);
//printf("padre del padre %d\n",nodo);
cupan=1;
pan[0]=nodo;
pan[1]=nodo;
menuok();
}

//////////////////////////////////////////////////////////////////////////



void UIReset(void)
{
u16 n;
tempsui=0;
for(n=0;n!=TAMV;n++)pan[n]=0;
cupan=1;
pan[0]=1;
pan[1]=1;
menuok();
eui=0;
blink=BLINK;
}

u8 key;
void UIRead(void)
{
void (*p)(void);
u16 a;
key=KEYBOARDRead();
if(key==0)return;
if(key==END)HWStop();
tempsui=0;
for(cupar=0;cupar!=MAXPAR;cupar++)if(par[cupar].nodo==pan[cupan])break;
a=par[cupar].flags;
switch(eui)
  {
  case 0:
	switch(key)
	  {
	  case OK:    if(a&MENU)menuok(); else
				  if(a&EDIT){eui=1;edit();} else
				  if(par[cupar].pSet){p=par[cupar].pSet;(*p)();}
				  break;
	  case ESC:   menuesc();    break;
	  case UP:    cursorup();   break;
	  case DOWN:  cursordown(); break;
	  }
	  break;
  case 1:
	switch(key)
	  {
	  case OK:    edit_ok(); eui=0; break;
	  case ESC:   eui=0; break;
	  case UP:    incrementaaux(); break;
	  case DOWN:  decrementaaux(); break;
	  }
	  break;
  }
//printf("\n\neui=%d pan[cupan=%d]=par[cupar=%d]=%d flags=%d \n",
//    eui,cupan,cupar,pan[cupan],par[cupar].flags);
}



////////////////////////////////////////////////////////////////////////



void edit(void)
{
u16 f;
u8  *u;
u16 *w;
s16 *s;
u32 *q;
s32  l;
//llamar a la funcion preedit !!??
q=(void*)(par[cupar].pVar);
if(q==0)return;
u=(u8*) (q);
s=(s16*)(q);
w=(u16*)(q);
f=par[cupar].flags;
//faltaria llamar a la funcion de previsualizacion !!
if(f&U8) lauxe=(*u); else
if(f&U32)lauxe=(*q); else
if(f&S16)lauxe=(*s); else
if(f&U16)lauxe=(*w);
}


void edit_ok(void)
{
u16 f;
u8  *u;
u16 *w;
s16 *s;
u32 *q;
s32  l;
//llamar a la funcion postedit !!??
q=(void*)(par[cupar].pVar);
if(q==0)return;
u=(u8*) (q);
s=(s16*)(q);
w=(u16*)(q);
f=par[cupar].flags;
//faltaria llamar a la funcion de previsualizacion !!
if(f&U8) *u=(u8) (lauxe); else
if(f&U32)*q=(u32)(lauxe); else
if(f&S16)*s=(s16)(lauxe);
if(f&U16)*w=(u16)(lauxe);
if(f&E2P)
		{
		//guarda valor en la eeprom
		u16 a;
		u32 d;
		a=cupar<<2;
		d=lauxe; EEPROMWrite(a  ,(u8)d);  //LSB
		d>>=8;   EEPROMWrite(a+1,(u8)d);
		d>>=8;   EEPROMWrite(a+2,(u8)d);
		d>>=8;   EEPROMWrite(a+3,(u8)d);  //MSB
		}
}


void view(u16 n)
{
//view
u16 f;
u8  *u;
u16 *w;
s16 *s;
u32 *q;
void (*p)(void);
p=par[n].pGet;
if(p)
	(*p)();
q=(void*)(par[n].pVar);
if(q)
	{
	u=(u8*) (q);
	w=(u16*)(q);
	s=(s16*)(q);
	f=par[n].flags;
	//faltaria llamar a la funcion de previsualizacion !!
	if(f&U8) lauxv=*u; else
	if(f&U32)lauxv=*q; else
	if(f&S16)lauxv=*s; else
	if(f&U16)lauxv=*w;
	}
//v=(void*)(par[n].pGet);
//if(v)(*v)();
}


void UIWrite(void)
{
u16 n,m;
//solo actualizo la pantalla cada 1000ms
//if(temps<tempsui)return;
//tempsui=temps+REFRESHTIME;
//idea: continuo si alguna de las variables monitorizadas ha cambiado de valor
LCD44780GoToX(0);
for(n=0;n!=TAMV;n++)
  {
  //for(m=0;m!=MAXPAR;m++)if(par[m].nodo==pan[n])break;
  for(m=0;m!=MAXPAR&&par[m].nodo!=pan[n];)
  m++;
  //if(!cambio)continue; verificar si el dato ha sufido modificacion
  if(n==cupan&&eui==1)
	{
	//edicion parametro
    lauxv=lauxe;
    GenLin(m);
	if(blink){ s[0]=' '; blink=0; }
	else  	 { s[0]='>'; blink=1; }
	}
  else
	{
	//visualizo parametro
    view(m);
    GenLin(m);
	if(n==cupan)s[0]='>';
	}
  LCDGotoXY(0,n);
  for(m=0;m!=TAMH&&s[m]!=0;m++)
    {
    LCDWrite(s[m]);
    LCD44780Write(s[m]);
    }
  }
}


////////////////////////////////////////////////////////////////////////

void GenLin(u16 n)
{
u16 m;
for(m=0;m!=TAMH;m++)s[m]=' '; //borro contenido
//s[0]='x';
//s[1]='y';
//s[2]='z';
if(n==MAXPAR)return;    //esto no deberia ocurrir

//return;

//texto
if(uIdioma==1)strncpy2(&s[1],(ENROM char*)(par[n].nome),TAMH); //ingles
else          strncpy2(&s[1],(ENROM char*)(par[n].nom ),TAMH); //espanyol

//si no hay puntero a variable o a funcion viusalizadora, retorno
if(!(par[n].pVar||par[n].pView))return;

//unidad medida
if(par[n].um[0]>' ')
	{
	//strlcpy(&s[TAMH-1],&(par[n].um[MAXUM-1]),MAXUM);
	char ENROM  *p,*q;
	char len;
	p=par[n].um;
	for(len=0;p[len]!=0;len++);
	q=p+len-1;
	strlcpy(&s[TAMH-1],q,len);
	//printf("\n[%s] len=%d   {%s}       \n",par[n].um,len,s);
	//numero
	for(m=TAMH-1;n&&s[m]!=' ';m--);  // busco el primer blanco antes um
	m--;
	}
else
	{
	m=TAMH-1;
	}
//m=TAMH-1;

VerS32(&s[m],lauxv);
}


